<?php
/*  Nom du programme: sauveTelephone.php
 *  Description :  Contrles les champs vides et invalides
 *                 d'une formulaire. Les champs valides sont
 *                 sauvegards dans une base de donnes.
 */
?>
<html>
<head>
<title>Numro de tlphone des membres</title>
</head>
<body>
<?php
  $prnom = strip_tags(trim($_POST['prnom']));
  $nom = strip_tags(trim($_POST['nom']));
  $tph = strip_tags(trim($_POST['tph']));
  $tph = ereg_replace("[/)( .-]","",$tph);

  /* ----- Contrle des informations du formulaire ----- */

  /* Dfinition des tiquettes de variables */
  $tiquettes = array ( "prnom" => "Prnom",
                         "nom" => "Nom",
                         "tph" => "Tlphone");
  foreach ($_POST as $cl => $valeur)
  {
    /* Recherche les champs vides */
    if ( $valeur == "" )
    {
        $champVide[$cl] = "blanc";
    }
    elseif ( ereg("(nom)",$cl))
    {
      if (!ereg("^[A-Za-z' -]{1,50}$",$_POST[$cl]) )
      {
             $mauvaisFormat[$cl] = "mauvais";
      }
    }
    elseif ($cl == "tph")
    {
      if(!ereg("^[0-9)( -]{7,20}(([xX]|(ext)|(ex))?[ -]?[0-9]{1,7})?$",$valeur) )
      {
             $mauvaisFormat[$cl] = "mauvais";
      }
    }
  } // Fin du foreach pour $_POST
  /* En cas d'erreur, afficher un message et rafficher le formulaire */
  if (@sizeof($champVide) > 0 or @sizeof($mauvaisFormat) > 0)
  {
    if (@sizeof($champVide) > 0)
    {
        /* Message signalant qu'il manque quelque chose */
        echo "<b>Vous avez omis de remplir un ou plusieurs champs obligatoires.
                 Vous devez saisir :</b><br>";
        /* Affiche la liste des informations absentes */
        foreach($champVide as $cl => $valeur)
        {
           echo "&nbsp;&nbsp;&nbsp;{$tiquettes[$cl]}<br>";
        }
    }
    if (@sizeof($mauvaisFormat) > 0)
    {
        /* Affiche un message signalant des informations invalides */
        echo "<b>OUn ou plusieurs champs contiennent une information
                 incorrecte. Corrigez les champs :</b><br>";
        /* Affiche la liste des informations invalides */
        foreach($mauvaisFormat as $cl => $valeur)
        {
           echo "&nbsp;&nbsp;&nbsp;{$tiquettes[$cl]}<br>";
        }
    }
    /* Raffiche le formulaire */
    echo "<p><hr>
      <form action='sauveTelephone.php' method='POST'>
      <center>
      <table width='95%' border='0' cellspacing='0' cellpadding='2'>
      <tr><td align='right'><B>{$tiquettes['prnom']}:</br></td>
        <td><input type='text' name='prnom' size='65' maxlength='65'
                    value='$prnom' > </td>
      </tr>
      <tr><td align='right'><B>{$tiquettes['nom']}:</B></td>
        <td> <input type='text' name='nom' size='65' maxlength='65'
                    value='$nom'> </td>
      </tr>
      <tr><td align='right'><B>{$tiquettes['tph']}:</B></td>
        <td> <input type='text' name='tph' size='65' maxlength='65'
                    value='$tph'> </td>
      </tr>
      </table>
      <p><input type='submit' value='Nom et numro de tlphone'>
      </form>
      </center>";
    exit();
  }
  else   // Si tout est OK
  {
    $user="admin";
    $host="localhost";
    $password="";
    $database = "MembresSeuls";
    $connection = mysql_connect($host,$user,$password)
       or die ("Connexion au serveur impossible.");
    $db = mysql_select_db($database,$connection)
       or die ("Slection de la base de donnes impossible.");

    $rq = "INSERT INTO Membre (nom,prnom,tph)
                     VALUES ('$nom','$prnom','$tph')";
    $result = mysql_query($rq)
       or die ("Excution de la requte impossible.");
    echo "Nouveau membre ajout  la base de donnes<br><br>";
  }
?>
</body>
</html>
