<?php
 /* Programme :  ProcessOrder.php
  * Description :   Traite la commande lorsqu'elle est soumise.
  */
session_start();                                         #5
include("functions_main.inc");
if(!isset($_SESSION['order_number']))                    #7
{
   echo "N de commande introuvable<br>\n";
   header("Location: ShopCatalog.php");
   exit();
}
if(@$_GET['from'] == "cart")                            #13
{
   include("fields_ship_info.inc");
   include("single_form.inc");
   exit();
}
elseif(isset($_POST['Summary']))                        #19
{
   foreach($_POST as $field => $value)                  #21
   {
      if ($value == "")
      {
         $blanks[] = $field;
      }
   }  
   if(isset($blanks))
   {
      $message = "Les champs suivants sont vides. 
                  Merci d'entrer les informations requises :  ";
      foreach($blanks as $value)
      {
         $message .="$value, ";
      }
      extract($_POST);
      include("fields_ship_info.inc");
      include("single_form.inc");
      exit();
   }
   foreach($_POST as $field => $value)                  #41
   {
     if($field != "Summary")
     {
       if(eregi("name",$field))
       {
         if (!ereg("^[A-Za-z' -]{1,50}$",$value)) 
         {
            $errors[] = "$value n'est pas un nom valide."; 
         }
       }
       if(eregi("street",$field)or eregi("addr",$field) or
          eregi("city",$field))
       {
         if(!ereg("^[A-Za-z0-9.,' -]{1,50}$",$value))
         {
            $errors[] = "$value n'est pas une adresse ou ville 
                          valide.";
         }
       }
       if(eregi("state",$field))
       {
         if(!ereg("[A-Za-z]",$value))
         {
            $errors[] = "$value n'est pas un tat valide.";
         }
       }
       if(eregi("email",$field))
       {
         if(!ereg("^.+@.+\\..+$",$value))
         {
            $errors[]="$value n'est pas un e-mail valide.";
         }
       }
       if(eregi("zip",$field))
       {
         if(!ereg("^[0-9]{5,5}(\-[0-9]{4,4})?$",$value))
         {
            $errors[] = "$value n'est pas un code postal valide.";
         }
       }
       if(eregi("phone",$field))
       {
         if(!ereg("^[0-9)(xX -]{7,20}$",$value))
         {
            $errors[]="$value n'est pas un n de tlphone valide. ";
         }
       }
       if(eregi("cc_number",$field))
       {
         $value = trim($value);
         $value = ereg_replace(' ','',$value);
         $value = ereg_replace('-','',$value);
         $_POST['cc_number'] = $value;
         if($_POST['cc_type'] == "visa") 
         {
           if(!ereg("^[4]{1,1}[0-9]{12,15}$",$value)) 
           {
             $errors[]="$value n'est pas un n Visa valide. ";
           }
         }
         elseif($_POST['cc_type'] == "mc")
         {
           if(!ereg("^[5]{1,1}[0-9]{15,15}$",$value))
           {
             $errors[] = "$value n'est pas un n 
             		Mastercard valid . ";
           }
         }
         else 
         {
           if(!ereg("^[3]{1,1}[0-9]{14,14}$",$value))
           { 
             $errors[] = "$value n'est pas un n
                           American Express valide. ";
           }
         }
       }
       $$field = strip_tags(trim($value));
     }
   }
   if(@is_array($errors))
   {  
      $message = "";
      foreach($errors as $value)
      {
         $message .= $value." Ressayez<br />";
      }
      include("fields_ship_info.inc");
      include("single_form.inc");
      exit();
   }                                                   #132
    /* Traite les donnes lorsque tous les champs sont corrects */
   foreach($_POST as $field => $value)                 #134
   {
      if(!eregi("cc_",$field) && $field != "Summary" ) #136
      {
         $value = addslashes($value);
         $updates[] = "$field = '$value'";
      }
   }
   $update_string = implode($updates,",");             #142
   $sql_ship = "UPDATE Customer_Order SET $update_string
          WHERE order_number='{$_SESSION['order_number']}'";
   $cxn = connect_to_db("Vars.inc");
   $result = mysqli_query($cxn,$sql_ship)
                 or die(mysqli_error($cxn));
   extract($_POST);                                    #148
   include("fields_summary.inc");
   include("summary_page.inc");
}
elseif(isset($_POST['Ship']))                          #152
{
   include("fields_ship_info.inc");
   include("single_form.inc");
}
elseif(isset($_POST['Final']))                         #157
{
   switch ($_POST['Final'])                            #159
   {
      case "Poursuivre les achats":                        #161
         header("Location: ShopCatalog.php");
         break;
      case "Annuler la commande":                             #164
         #include("fields_cancel.inc");
         #include("cancel_message.inc");
         unset($_SESSION['order_number']);
         session_destroy();
         exit();
         break;
      case "Valider la commande":                             #171
         $cxn = connect_to_db("Vars.inc");
         $sql = "UPDATE Customer_Order SET submitted='yes'
           WHERE order_number='{$_SESSION['order_number']}'";
         $result = mysqli_query($cxn,$sql)
                or die("Error: ".mysqli_error($cxn));
         #processCCInfo();                              #177
         #sendOrder();
         #include("fields_accept.inc");                 #179
         #include("accept_message.inc");
         #email();                                      #181
         session_destroy();                             #182
         break;
    }
}
?>
